// Copyright Vygintas D., 2003. All rights reserved.
//
// Permission to use, copy, modify, and distribute this software for any
// purpose is hereby granted without fee, provided that this copyright and
// permissions notice appear in all copies and derivatives.
//
// This software is provided "as is" without express or implied warranty.

#ifndef _SQRT_HPP_
#define _SQRT_HPP_

#include <cmath>

namespace math {

    // Sometimes ability to specialize sqrt operation
    // for certain types is really needed...

    template< typename T >
    struct sqrt_t
    {
        typedef T type;
        inline static T apply( const T v )
            { return ::sqrt(v); }
    };

    template<>
    struct sqrt_t< float >
    {
        typedef float type;
        inline static float apply( const float v )
            { return ::sqrtf(v); }
    };
    
} // namespace math

#endif // _SQRT_HPP_
